

// Accelerometer --------------------------------------------------

#include <MPU9250_asukiaaa.h>

#ifdef _ESP32_HAL_I2C_H_
#define SDA_PIN 21
#define SCL_PIN 22
#endif

MPU9250_asukiaaa mySensor;
float aX, aY, aZ, aSqrt;


// Accelerometer --------------------------------------------------

#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>

#define SCREEN_WIDTH 128 // OLED display width, in pixels
#define SCREEN_HEIGHT 64 // OLED display height, in pixels

#define OLED_RESET     -1 // Reset pin # (or -1 if sharing Arduino reset pin)
#define SCREEN_ADDRESS 0x3C ///< See datasheet for Address; 0x3D for 128x64, 0x3C for 128x32
Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, OLED_RESET);

int score = 0;
//int sspeed = 400;

int w_gap = 20;
int x_wall = 64;
int y_wall = 50;

double prev_time = 0;
double sspeed = 100; // wall moves every 400 millis


void updateWall(){
  if (y_wall==0){
  y_wall = SCREEN_HEIGHT;
  x_wall = random(w_gap/2, SCREEN_WIDTH-w_gap/2);
  score++;
  sspeed = 100 - score*5;
  if (ttspeed<=5){sspeed =5;}
  }

  double c_time = millis();
  if ((c_time-prev_time) > sspeed){
  y_wall--;
  prev_time=c_time;
  }
  
}

void displayWall(){
  display.drawRect(0, y_wall , x_wall-w_gap/2,10, SSD1306_WHITE);
  display.drawRect(x_wall+w_gap/2, y_wall , SCREEN_WIDTH - (x_wall+w_gap/2),10, SSD1306_WHITE);
}

void setup()
{
  Serial.begin(9600);

// LCD Setup --------------------
  if(!display.begin(SSD1306_SWITCHCAPVCC, SCREEN_ADDRESS)) {
    Serial.println(F("SSD1306 allocation failed"));
    for(;;); // Don't proceed, loop forever
  }
  
  display.clearDisplay();
  display.display();
// LCD Setup --------------------

// Accelerometer Setup ----------
#ifdef _ESP32_HAL_I2C_H_ // For ESP32
  Wire.begin(SDA_PIN, SCL_PIN);
  mySensor.setWire(&Wire);
#endif

  mySensor.beginAccel();

// Accelerometer Setup ----------
  
}

void updateAccelerometer(){
  uint8_t sensorId;
  int result;

  result = mySensor.readId(&sensorId);
  if (result == 0) {
    Serial.println("sensorId: " + String(sensorId));
  } else {
    Serial.println("Cannot read sensorId " + String(result));
  }

  result = mySensor.accelUpdate();
  if (result == 0) {
    aX = mySensor.accelX();
    aY = mySensor.accelY();
    aZ = mySensor.accelZ();
    aSqrt = mySensor.accelSqrt();
    Serial.println("accelX: " + String(aX));
    Serial.println("accelY: " + String(aY));
    Serial.println("accelZ: " + String(aZ));
    //Serial.println("accelSqrt: " + String(aSqrt));
  } else {
    //Serial.println("Cannod read accel values " + String(result));
  }
}

int initial_w_ship = 10;
int w_ship = 10;
int h_ship = 10;
int x_ship = SCREEN_WIDTH/2;
int y_ship = 0;

void updateShip()
{
  x_ship = -1*aY*SCREEN_WIDTH/2 + SCREEN_WIDTH/2 ;
  // use accelerometer data to update ship position
}

void resetGame(){
 display.clearDisplay();
 display.setTextSize(2.5); // Draw 2X-scale text
 display.setTextColor(SSD1306_WHITE);
 display.setCursor(10, 0);
 display.println("YOU LOSE");
 display.display();      // Show initial text
 delay(2000);
 display.setCursor(22, 30);
 display.setTextSize(1.5); // Draw 2X-scale text
 display.println("Play Again?");
 display.display();  
 delay(2000);
 score = 0;
 sspeed = 100;
}

void checkCollision(){
  int l_ship = x_ship - w_ship/2;
  int r_ship = x_ship + w_ship/2;
  int l_wall = x_wall - w_gap/2;
  int r_wall = x_wall + w_gap/2;

  //Serial.print("l_ship");  Serial.print(" "); 
  //Serial.print("r_ship");  Serial.print(" "); 
  //Serial.print("l_wall");  Serial.print(" "); 
  //Serial.print("r_wall");  Serial.println(" "); 

  if (y_ship+h_ship >= y_wall){
    if (l_ship < l_wall || r_ship > r_wall){
      y_wall = SCREEN_HEIGHT;
      resetGame();
    }
  }
}

int dist = 1000;

void displayGUI(){
  display.setTextSize(1);      // Normal 1:1 pixel scale
  display.setTextColor(SSD1306_WHITE); // Draw white text
  display.setCursor(0, 56);
  display.write("Score:");

  char Score[3];
  String str;
  str = String(score);
  str.toCharArray(Score,3);
  display.write(Score);

  display.setCursor(70, 56);
  display.write("Speed:");

  char SSpeed[4];
  str = String(sspeed);
  str.toCharArray(SSpeed,4);
  display.write(SSpeed);
  
  display.write(SSpeed);
  
}

void displayShip()
{
  double tilt = (1-abs(((double)x_ship - (double)SCREEN_WIDTH/2)/((double)SCREEN_WIDTH/2)));
  double w_ship = (initial_w_ship/2)*tilt;
  display.drawLine(x_ship + w_ship, 0, x_ship, h_ship, SSD1306_WHITE);
  display.drawLine(x_ship - w_ship, 0, x_ship, h_ship, SSD1306_WHITE);
  display.drawLine(x_ship - w_ship, 0, x_ship + w_ship, 0, SSD1306_WHITE); 
}

//int X= 32;

void loop(){
  display.clearDisplay();

  //X++;
  //if (X>96){ X=32;}
  //x_ship=X;
  updateAccelerometer();
  updateShip();
  displayShip();
  updateWall();
  displayWall();
  displayGUI();
  // Make this the last method
  checkCollision();
  //delay(500);
  display.display();
}
